<?php
function testPdo_Connection_Success(){
    $dsn = 'kdb:host=192.168.28.36;dbname=postgres;port=6432';
    $user = 'system';
    $password = 'MANAGER';
    $dbh = null;
    try {
        $dbh = new PDO($dsn,$user, $password, array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));
    } catch (Exception $e) {
        echo 'Connection Failed: ' . $e->getMessage() ."\n";
    }
    if(empty($dbh))
    {
        echo "testPdo_Connection failed!\n";
        die;
    }
    return $dbh;
}

function testNoTableCreateTable($dbh){
    $table_name = 'testfetch';
    //$sql = 'SELECT * FROM USER_TABLES WHERE TABLE_NAME = :table_name';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table testfetch');
    }
    $stmt = $dbh->prepare('create table testfetch(name char(20), height int, is_child int)');
    $stmt->execute();

    $table_name = 'testtab1';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table testtab1');
    }
    $stmt = $dbh->prepare('create table testtab1(id int, t int)');
    $stmt->execute();
    for($ids = 1,$ts = 1; $ids <= 10; $ids++ )
    {
        $stmt = $dbh->prepare('insert into testtab1 values(:ids,:ts)');
        $stmt->execute(array(':ids' => $ids,':ts' => $ts));
        $ts++;
    }

    $table_name = 'testtab2';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table testtab2');
    }
    $stmt = $dbh->prepare('create table testtab2(id char(20),file_char char(20))');
    $stmt->execute();

    $table_name = 'testtab3';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table testtab3');
    }
    $stmt = $dbh->prepare('create table testtab3(id int, field_int int,field_str char(20))');
    $stmt->execute();
    for($ids = 1,$ts = 1,$str = 'test_parm'; $ids <= 10; $ids++ )
    {
        $stmt = $dbh->prepare('insert into testtab3 values(:ids,:ts,:str)');
        $stmt->execute(array(':ids' => $ids,':ts' => $ts,':str' => $str));
        $ts++;
    }

    $table_name = 'test_sequence';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table test_sequence');
    }
    $stmt = $dbh->prepare('create table test_sequence(id SERIAL,t int)');
    $stmt->execute();

    $table_name = 'testblob';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table testblob');
    }
    $stmt = $dbh->prepare('create table testblob(id int, bb blob, cb clob)');
    $stmt->execute();

    $table_name = 'test_new_data_type';
    $stmt = $dbh->prepare('SELECT * FROM pg_tables WHERE tablename = :table_name');
    $stmt->execute(array(':table_name' => $table_name));
    $count = $stmt->rowCount();
    if(1 == $count)
    {
        $dbh->exec('drop table test_new_data_type');
    }
    $stmt = $dbh->prepare('create table test_new_data_type(fnclob nclob, fbpcharbyte bpcharbyte, f_bpcharbyte _bpcharbyte, '.
        'fvarcharbyte varcharbyte, f_varcharbyte _varcharbyte, fora_date date)');
    $ret = $stmt->execute();

    if(TRUE != $ret)
    {
        echo "create table test_new_data_type failed!\n";
        die;
    }

    $stmt = $dbh->prepare('insert into test_new_data_type values(:a,:b,:c,:d,:e,:f)');
    $stmt->execute(array(':a' => 'nclob string', ':b' => 'bpcharbyte string', ':c' => '{_bpcharbyte string}',
                ':d' => 'varcharbyte string', ':e' => '{_varcharbyte string}', ':f' => '2020-02-22 13:28:32', ));
    $stmt = $dbh->prepare('SELECT * FROM test_new_data_type');
    $stmt->execute();

    if(FALSE == $stmt->fetchAll())
    {
        echo "fetch data from test_new_data_type failed!\n";
        die;
    }
}

$dbh = testPdo_Connection_Success();

testNoTableCreateTable($dbh);

echo "*************************************************\n";
echo "All tests passed!\n";
echo "*************************************************\n";

?>
